'' =================================================================================================
''
''   File....... jm_dmxrgb.spin
''   Purpose.... Simple RGB LED controller via DMX-512 
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2009 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started.... 01 SEP 2009
''   Updated.... 19 SEP 2009
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  
obj

  dmx : "jm_dmxin"
  rgb : "jm_bam_rgb"   


pub main | dmxstart, chan, level

  dmx.init(24, 16)                                              ' for DMX IO board
  rgb.init(9, 10, 11)

  repeat
    chan := ina[0..8]                                           ' read address switch
    if (chan > 0) & (dmx.read(0) == 0)                          ' if legal chan and start
      level := dmx.read(chan++)                                 ' get level
      rgb.setred(rgb.ezlog(level))                              ' linearize
      level := dmx.read(chan++)
      rgb.setgreen(rgb.ezlog(level))
      level := dmx.read(chan)
      rgb.setblue(rgb.ezlog(level)) 
    else
      rgb.setall(0)
      

dat

{{

  Copyright (c) 2009 Jon McPhalen (aka Jon Williams)

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 

}}

                 